mod base;
mod files;

use crate::models::*;
pub use base::{AsMsg, BaseMessage};
pub use files::*;
use serde::{Deserialize, Serialize};
use std::fmt;
use uuid::Uuid;

impl AsMsg for Agent {}
impl AsMsg for AssignedJob {}
impl AsMsg for DownloadInfo {}
impl AsMsg for ExecResult {}
impl AsMsg for JobMeta {}
impl AsMsg for String {}
impl AsMsg for Uuid {}
impl AsMsg for Empty {}
impl AsMsg for i32 {}
impl AsMsg for u8 {}

#[derive(Serialize, Deserialize, Clone, Default, Debug)]
pub struct Empty;

impl fmt::Display for Empty {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "<empty>")
    }
}
